//+------------------------------------------------------------------+
//|                                                      MTF_ADX.mq4 |
//|                                      Copyright  2006, Keris2112 |
//|                            MTF 2006 Keris2112 www.forex-tsd.com  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Keris2112"
#property link      "http://www.forex-tsd.com"


#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Blue
#property indicator_color2 Lime
#property indicator_color3 Red
#property indicator_width1 1
#property indicator_level1 20
#property indicator_levelcolor DarkSlateGray

//#property indicator_level2 100
//#property indicator_level3 -100

//#property indicator_maximum 400
//#property indicator_minimum -400


extern int TimeFrame=0;
extern int ADX_period1=14;
extern int ADX_period2=26;
extern int ADX_period3=52;


//extern int MaxBarsToCount = 1500;

//extern string  note__MaMode_Price = "Price(OCHLMTF)ModeMa(SMA0,EMA1,SmmMA2,LWMA3";
extern string  note_TimeFrames = "M1;5,15,30,60H1;240H4;1440D1;10080W1;43200MN|0-CurrentTF";


double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];


//+------------------------------
int init()
  {


   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexBuffer(2,ExtMapBuffer3);
   
   
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);
 
 
   SetIndexLabel(0,   "ADX1 ("+ADX_period1+"["+TimeFrame+"]");
   SetIndexLabel(1,   "ADX2 ("+ADX_period2+"["+TimeFrame+"]");
   SetIndexLabel(2,   "ADX3 ("+ADX_period3+"["+TimeFrame+"]");

//---- 
  TimeFrame = MathMax(TimeFrame,Period());

      switch(TimeFrame)
       {
          case 1  : string TimeFrameStr= "M1" ;   break;
          case 5  :     TimeFrameStr=    "M5" ;   break;
          case 15 :     TimeFrameStr=    "M15";   break;
          case 30 :     TimeFrameStr=    "M30";   break;
          case 60 :     TimeFrameStr=    "H1" ;   break;
          case 240   :  TimeFrameStr=    "H4" ;   break;
          case 1440  :  TimeFrameStr=    "D1" ;   break;
          case 10080 :  TimeFrameStr=    "W1" ;   break;
          case 43200 :  TimeFrameStr=    "MN" ;   break;
          default  :    TimeFrameStr=    "TF0";
       }   

   IndicatorShortName(" ADX: "+ADX_period1+", "+ADX_period2+", "+ADX_period3+";  ["+TimeFrameStr+"] ");

  }
//----
   return(0);
 
 
 
//+---------------------------------------+

int start()
  {
   datetime TimeArray[];
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 

   int    i,limit,y=0,counted_bars=IndicatorCounted();
 

   limit=Bars-counted_bars;
   limit=MathMax(limit,TimeFrame/Period());
// limit=MathMin(limit,MaxBarsToCount);  

   for(i=0,y=0;i<limit;i++)
   {
      if (Time[i]<TimeArray[y]) y++;

      ExtMapBuffer1[i]=iADX(NULL,TimeFrame,ADX_period1,0,0,y) ; 
      ExtMapBuffer2[i]=iADX(NULL,TimeFrame,ADX_period2,0,0,y) ; 
      ExtMapBuffer3[i]=iADX(NULL,TimeFrame,ADX_period3,0,0,y) ; 
   
   }  


   return(0);
  }
  
//+------------------------------------------------------------------+